diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/update.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/update.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/update.php	2013-01-04 04:13:51.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/update.php	2013-10-23 09:40:10.000000000 -0500
***************
*** 17,25 ****
   * @since 2.3.0
   * @uses $wp_version Used to check against the newest WordPress version.
   *
   * @return mixed Returns null if update is unsupported. Returns false if check is too soon.
   */
! function wp_version_check() {
  	if ( defined('WP_INSTALLING') )
  		return;
  
--- 17,26 ----
   * @since 2.3.0
   * @uses $wp_version Used to check against the newest WordPress version.
   *
+  * @param array $extra_stats Extra statistics to report to the WordPress.org API.
   * @return mixed Returns null if update is unsupported. Returns false if check is too soon.
   */
! function wp_version_check( $extra_stats = array() ) {
  	if ( defined('WP_INSTALLING') )
  		return;
  
***************
*** 28,33 ****
--- 29,36 ----
  	$php_version = phpversion();
  
  	$current = get_site_transient( 'update_core' );
+ 	$translations = wp_get_installed_translations( 'core' );
+ 
  	if ( ! is_object($current) ) {
  		$current = new stdClass;
  		$current->updates = array();
***************
*** 37,46 ****
  	// Wait 60 seconds between multiple version check requests
  	$timeout = 60;
  	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
! 	if ( $time_not_changed )
  		return false;
  
! 	$locale = apply_filters( 'core_version_check_locale', get_locale() );
  
  	// Update last_checked for current to prevent multiple blocking requests if request hangs
  	$current->last_checked = time();
--- 40,57 ----
  	// Wait 60 seconds between multiple version check requests
  	$timeout = 60;
  	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
! 	if ( $time_not_changed && empty( $extra_stats ) )
  		return false;
  
! 	$locale = get_locale();
! 	/**
! 	 * Filter the locale requested for WordPress core translations.
! 	 *
! 	 * @since 2.8.0
! 	 *
! 	 * @param string $locale Current locale.
! 	 */
! 	$locale = apply_filters( 'core_version_check_locale', $locale );
  
  	// Update last_checked for current to prevent multiple blocking requests if request hangs
  	$current->last_checked = time();
***************
*** 72,81 ****
  		'local_package'     => isset( $wp_local_package ) ? $wp_local_package : '',
  		'blogs'             => $num_blogs,
  		'users'             => $user_count,
! 		'multisite_enabled' => $multisite_enabled
  	);
  
! 	$url = 'http://api.wordpress.org/core/version-check/1.6/?' . http_build_query( $query, null, '&' );
  
  	$options = array(
  		'timeout' => ( ( defined('DOING_CRON') && DOING_CRON ) ? 30 : 3 ),
--- 83,101 ----
  		'local_package'     => isset( $wp_local_package ) ? $wp_local_package : '',
  		'blogs'             => $num_blogs,
  		'users'             => $user_count,
! 		'multisite_enabled' => $multisite_enabled,
! 	);
! 
! 	$post_body = array(
! 		'translations' => json_encode( $translations ),
  	);
  
! 	if ( $extra_stats )
! 		$post_body = array_merge( $post_body, $extra_stats );
! 
! 	$url = 'http://api.wordpress.org/core/version-check/1.7/?' . http_build_query( $query, null, '&' );
! 	if ( wp_http_supports( array( 'ssl' ) ) )
! 		$url = set_url_scheme( $url, 'https' );
  
  	$options = array(
  		'timeout' => ( ( defined('DOING_CRON') && DOING_CRON ) ? 30 : 3 ),
***************
*** 83,98 ****
  		'headers' => array(
  			'wp_install' => $wp_install,
  			'wp_blog' => home_url( '/' )
! 		)
  	);
  
! 	$response = wp_remote_get($url, $options);
  
  	if ( is_wp_error( $response ) || 200 != wp_remote_retrieve_response_code( $response ) )
  		return false;
  
  	$body = trim( wp_remote_retrieve_body( $response ) );
! 	$body = maybe_unserialize( $body );
  
  	if ( ! is_array( $body ) || ! isset( $body['offers'] ) )
  		return false;
--- 103,119 ----
  		'headers' => array(
  			'wp_install' => $wp_install,
  			'wp_blog' => home_url( '/' )
! 		),
! 		'body' => $post_body,
  	);
  
! 	$response = wp_remote_post( $url, $options );
  
  	if ( is_wp_error( $response ) || 200 != wp_remote_retrieve_response_code( $response ) )
  		return false;
  
  	$body = trim( wp_remote_retrieve_body( $response ) );
! 	$body = json_decode( $body, true );
  
  	if ( ! is_array( $body ) || ! isset( $body['offers'] ) )
  		return false;
***************
*** 103,122 ****
  		foreach ( $offer as $offer_key => $value ) {
  			if ( 'packages' == $offer_key )
  				$offer['packages'] = (object) array_intersect_key( array_map( 'esc_url', $offer['packages'] ),
! 					array_fill_keys( array( 'full', 'no_content', 'new_bundled', 'partial' ), '' ) );
  			elseif ( 'download' == $offer_key )
  				$offer['download'] = esc_url( $value );
  			else
  				$offer[ $offer_key ] = esc_html( $value );
  		}
  		$offer = (object) array_intersect_key( $offer, array_fill_keys( array( 'response', 'download', 'locale',
! 			'packages', 'current', 'php_version', 'mysql_version', 'new_bundled', 'partial_version' ), '' ) );
  	}
  
  	$updates = new stdClass();
  	$updates->updates = $offers;
  	$updates->last_checked = time();
  	$updates->version_checked = $wp_version;
  	set_site_transient( 'update_core',  $updates);
  }
  
--- 124,147 ----
  		foreach ( $offer as $offer_key => $value ) {
  			if ( 'packages' == $offer_key )
  				$offer['packages'] = (object) array_intersect_key( array_map( 'esc_url', $offer['packages'] ),
! 					array_fill_keys( array( 'full', 'no_content', 'new_bundled', 'partial', 'rollback' ), '' ) );
  			elseif ( 'download' == $offer_key )
  				$offer['download'] = esc_url( $value );
  			else
  				$offer[ $offer_key ] = esc_html( $value );
  		}
  		$offer = (object) array_intersect_key( $offer, array_fill_keys( array( 'response', 'download', 'locale',
! 			'packages', 'current', 'version', 'php_version', 'mysql_version', 'new_bundled', 'partial_version', 'notify_email' ), '' ) );
  	}
  
  	$updates = new stdClass();
  	$updates->updates = $offers;
  	$updates->last_checked = time();
  	$updates->version_checked = $wp_version;
+ 
+ 	if ( isset( $body['translations'] ) )
+ 		$updates->translations = $body['translations'];
+ 
  	set_site_transient( 'update_core',  $updates);
  }
  
***************
*** 144,149 ****
--- 169,176 ----
  		require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
  
  	$plugins = get_plugins();
+ 	$translations = wp_get_installed_translations( 'plugins' );
+ 
  	$active  = get_option( 'active_plugins', array() );
  	$current = get_site_transient( 'update_plugins' );
  	if ( ! is_object($current) )
***************
*** 154,159 ****
--- 181,189 ----
  
  	// Check for update on a different schedule, depending on the page.
  	switch ( current_filter() ) {
+ 		case 'upgrader_process_complete' :
+ 			$timeout = 0;
+ 			break;
  		case 'load-update-core.php' :
  			$timeout = MINUTE_IN_SECONDS;
  			break;
***************
*** 194,218 ****
  	$current->last_checked = time();
  	set_site_transient( 'update_plugins', $current );
  
! 	$to_send = (object) compact('plugins', 'active');
  
  	$options = array(
  		'timeout' => ( ( defined('DOING_CRON') && DOING_CRON ) ? 30 : 3),
! 		'body' => array( 'plugins' => serialize( $to_send ) ),
  		'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' )
  	);
  
! 	$raw_response = wp_remote_post('http://api.wordpress.org/plugins/update-check/1.0/', $options);
  
  	if ( is_wp_error( $raw_response ) || 200 != wp_remote_retrieve_response_code( $raw_response ) )
  		return false;
  
! 	$response = maybe_unserialize( wp_remote_retrieve_body( $raw_response ) );
! 
! 	if ( is_array( $response ) )
! 		$new_option->response = $response;
! 	else
  		$new_option->response = array();
  
  	set_site_transient( 'update_plugins', $new_option );
  }
--- 224,273 ----
  	$current->last_checked = time();
  	set_site_transient( 'update_plugins', $current );
  
! 	$to_send = compact( 'plugins', 'active' );
! 
! 	$locales = array( get_locale() );
! 	/**
! 	 * Filter the locales requested for plugin translations.
! 	 *
! 	 * @since 3.7.0
! 	 *
! 	 * @param array $locales Plugin locale. Default is current locale of the site.
! 	 */
! 	$locales = apply_filters( 'plugins_update_check_locales', $locales );
  
  	$options = array(
  		'timeout' => ( ( defined('DOING_CRON') && DOING_CRON ) ? 30 : 3),
! 		'body' => array(
! 			'plugins'      => json_encode( $to_send ),
! 			'translations' => json_encode( $translations ),
! 			'locale'       => json_encode( $locales ),
! 		),
  		'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' )
  	);
  
! 	$url = 'http://api.wordpress.org/plugins/update-check/1.1/';
! 	if ( wp_http_supports( array( 'ssl' ) ) )
! 		$url = set_url_scheme( $url, 'https' );
! 
! 	$raw_response = wp_remote_post( $url, $options );
  
  	if ( is_wp_error( $raw_response ) || 200 != wp_remote_retrieve_response_code( $raw_response ) )
  		return false;
  
! 	$response = json_decode( wp_remote_retrieve_body( $raw_response ), true );
! 	foreach ( $response['plugins'] as &$plugin ) {
! 		$plugin = (object) $plugin;
! 	}
! 	unset( $plugin );
! 
! 	if ( is_array( $response ) ) {
! 		$new_option->response = $response['plugins'];
! 		$new_option->translations = $response['translations'];
! 	} else {
  		$new_option->response = array();
+ 		$new_option->translations = array();
+ 	}
  
  	set_site_transient( 'update_plugins', $new_option );
  }
***************
*** 237,251 ****
  		return false;
  
  	$installed_themes = wp_get_themes();
  	$last_update = get_site_transient( 'update_themes' );
  	if ( ! is_object($last_update) )
  		$last_update = new stdClass;
  
! 	$themes = array();
! 	$checked = array();
  
  	// Put slug of current theme into request.
! 	$themes['current_theme'] = get_option( 'stylesheet' );
  
  	foreach ( $installed_themes as $theme ) {
  		$checked[ $theme->get_stylesheet() ] = $theme->get('Version');
--- 292,307 ----
  		return false;
  
  	$installed_themes = wp_get_themes();
+ 	$translations = wp_get_installed_translations( 'themes' );
+ 
  	$last_update = get_site_transient( 'update_themes' );
  	if ( ! is_object($last_update) )
  		$last_update = new stdClass;
  
! 	$themes = $checked = $request = array();
  
  	// Put slug of current theme into request.
! 	$request['active'] = get_option( 'stylesheet' );
  
  	foreach ( $installed_themes as $theme ) {
  		$checked[ $theme->get_stylesheet() ] = $theme->get('Version');
***************
*** 263,268 ****
--- 319,327 ----
  
  	// Check for update on a different schedule, depending on the page.
  	switch ( current_filter() ) {
+ 		case 'upgrader_process_complete' :
+ 			$timeout = 0;
+ 			break;
  		case 'load-update-core.php' :
  			$timeout = MINUTE_IN_SECONDS;
  			break;
***************
*** 301,313 ****
  	$last_update->last_checked = time();
  	set_site_transient( 'update_themes', $last_update );
  
  	$options = array(
  		'timeout' => ( ( defined('DOING_CRON') && DOING_CRON ) ? 30 : 3),
! 		'body'			=> array( 'themes' => serialize( $themes ) ),
  		'user-agent'	=> 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' )
  	);
  
! 	$raw_response = wp_remote_post( 'http://api.wordpress.org/themes/update-check/1.0/', $options );
  
  	if ( is_wp_error( $raw_response ) || 200 != wp_remote_retrieve_response_code( $raw_response ) )
  		return false;
--- 360,392 ----
  	$last_update->last_checked = time();
  	set_site_transient( 'update_themes', $last_update );
  
+ 	$request['themes'] = $themes;
+ 
+ 	$locales = array( get_locale() );
+ 	/**
+ 	 * Filter the locales requested for theme translations.
+ 	 *
+ 	 * @since 3.7.0
+ 	 *
+ 	 * @param array $locales Theme locale. Default is current locale of the site.
+ 	 */
+ 	$locales = apply_filters( 'themes_update_check_locales', $locales );
+ 
  	$options = array(
  		'timeout' => ( ( defined('DOING_CRON') && DOING_CRON ) ? 30 : 3),
! 		'body' => array(
! 			'themes'       => json_encode( $request ),
! 			'translations' => json_encode( $translations ),
! 			'locale'       => json_encode( $locales ),
! 		),
  		'user-agent'	=> 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' )
  	);
  
! 	$url = 'http://api.wordpress.org/themes/update-check/1.1/';
! 	if ( wp_http_supports( array( 'ssl' ) ) )
! 		$url = set_url_scheme( $url, 'https' );
! 
! 	$raw_response = wp_remote_post( $url, $options );
  
  	if ( is_wp_error( $raw_response ) || 200 != wp_remote_retrieve_response_code( $raw_response ) )
  		return false;
***************
*** 316,328 ****
  	$new_update->last_checked = time();
  	$new_update->checked = $checked;
  
! 	$response = maybe_unserialize( wp_remote_retrieve_body( $raw_response ) );
! 	if ( is_array( $response ) )
! 		$new_update->response = $response;
  
  	set_site_transient( 'update_themes', $new_update );
  }
  
  /*
   * Collect counts and UI strings for available updates
   *
--- 395,445 ----
  	$new_update->last_checked = time();
  	$new_update->checked = $checked;
  
! 	$response = json_decode( wp_remote_retrieve_body( $raw_response ), true );
! 
! 	if ( is_array( $response ) ) {
! 		$new_update->response     = $response['themes'];
! 		$new_update->translations = $response['translations'];
! 	}
  
  	set_site_transient( 'update_themes', $new_update );
  }
  
+ /**
+  * Performs WordPress automatic background updates.
+  *
+  * @since 3.7.0
+  */
+ function wp_maybe_auto_update() {
+ 	include_once ABSPATH . '/wp-admin/includes/admin.php';
+ 	include_once ABSPATH . '/wp-admin/includes/class-wp-upgrader.php';
+ 
+ 	$upgrader = new WP_Automatic_Updater;
+ 	$upgrader->run();
+ }
+ 
+ /**
+  * Retrieves a list of all language updates available.
+  *
+  * @since 3.7.0
+  */
+ function wp_get_translation_updates() {
+ 	$updates = array();
+ 	$transients = array( 'update_core' => 'core', 'update_plugins' => 'plugin', 'update_themes' => 'theme' );
+ 	foreach ( $transients as $transient => $type ) {
+ 
+ 		$transient = get_site_transient( $transient );
+ 		if ( empty( $transient->translations ) )
+ 			continue;
+ 
+ 		foreach ( $transient->translations as $translation ) {
+ 			$updates[] = (object) $translation;
+ 		}
+ 	}
+ 
+ 	return $updates;
+ }
+ 
  /*
   * Collect counts and UI strings for available updates
   *
***************
*** 331,357 ****
   * @return array
   */
  function wp_get_update_data() {
! 	$counts = array( 'plugins' => 0, 'themes' => 0, 'wordpress' => 0 );
  
! 	if ( current_user_can( 'update_plugins' ) ) {
  		$update_plugins = get_site_transient( 'update_plugins' );
  		if ( ! empty( $update_plugins->response ) )
  			$counts['plugins'] = count( $update_plugins->response );
  	}
  
! 	if ( current_user_can( 'update_themes' ) ) {
  		$update_themes = get_site_transient( 'update_themes' );
  		if ( ! empty( $update_themes->response ) )
  			$counts['themes'] = count( $update_themes->response );
  	}
  
! 	if ( function_exists( 'get_core_updates' ) && current_user_can( 'update_core' ) ) {
  		$update_wordpress = get_core_updates( array('dismissed' => false) );
  		if ( ! empty( $update_wordpress ) && ! in_array( $update_wordpress[0]->response, array('development', 'latest') ) && current_user_can('update_core') )
  			$counts['wordpress'] = 1;
  	}
  
! 	$counts['total'] = $counts['plugins'] + $counts['themes'] + $counts['wordpress'];
  	$titles = array();
  	if ( $counts['wordpress'] )
  		$titles['wordpress'] = sprintf( __( '%d WordPress Update'), $counts['wordpress'] );
--- 448,477 ----
   * @return array
   */
  function wp_get_update_data() {
! 	$counts = array( 'plugins' => 0, 'themes' => 0, 'wordpress' => 0, 'translations' => 0 );
  
! 	if ( $plugins = current_user_can( 'update_plugins' ) ) {
  		$update_plugins = get_site_transient( 'update_plugins' );
  		if ( ! empty( $update_plugins->response ) )
  			$counts['plugins'] = count( $update_plugins->response );
  	}
  
! 	if ( $themes = current_user_can( 'update_themes' ) ) {
  		$update_themes = get_site_transient( 'update_themes' );
  		if ( ! empty( $update_themes->response ) )
  			$counts['themes'] = count( $update_themes->response );
  	}
  
! 	if ( ( $core = current_user_can( 'update_core' ) ) && function_exists( 'get_core_updates' ) ) {
  		$update_wordpress = get_core_updates( array('dismissed' => false) );
  		if ( ! empty( $update_wordpress ) && ! in_array( $update_wordpress[0]->response, array('development', 'latest') ) && current_user_can('update_core') )
  			$counts['wordpress'] = 1;
  	}
  
! 	if ( ( $core || $plugins || $themes ) && wp_get_translation_updates() )
! 		$counts['translations'] = 1;
! 
! 	$counts['total'] = $counts['plugins'] + $counts['themes'] + $counts['wordpress'] + $counts['translations'];
  	$titles = array();
  	if ( $counts['wordpress'] )
  		$titles['wordpress'] = sprintf( __( '%d WordPress Update'), $counts['wordpress'] );
***************
*** 359,368 ****
  		$titles['plugins'] = sprintf( _n( '%d Plugin Update', '%d Plugin Updates', $counts['plugins'] ), $counts['plugins'] );
  	if ( $counts['themes'] )
  		$titles['themes'] = sprintf( _n( '%d Theme Update', '%d Theme Updates', $counts['themes'] ), $counts['themes'] );
  
  	$update_title = $titles ? esc_attr( implode( ', ', $titles ) ) : '';
  
! 	return apply_filters( 'wp_get_update_data', array( 'counts' => $counts, 'title' => $update_title ), $titles );
  }
  
  function _maybe_update_core() {
--- 479,504 ----
  		$titles['plugins'] = sprintf( _n( '%d Plugin Update', '%d Plugin Updates', $counts['plugins'] ), $counts['plugins'] );
  	if ( $counts['themes'] )
  		$titles['themes'] = sprintf( _n( '%d Theme Update', '%d Theme Updates', $counts['themes'] ), $counts['themes'] );
+ 	if ( $counts['translations'] )
+ 		$titles['translations'] = __( 'Translation Updates' );
  
  	$update_title = $titles ? esc_attr( implode( ', ', $titles ) ) : '';
  
! 	$update_data = array( 'counts' => $counts, 'title' => $update_title );
! 	/**
! 	 * Filter the returned array of update data for plugins, themes, and WordPress core.
! 	 *
! 	 * @since 3.5.0
! 	 *
! 	 * @param array $update_data {
! 	 *     Fetched update data.
! 	 *
! 	 *     @type array   $counts       An array of counts for available plugin, theme, and WordPress updates.
! 	 *     @type string  $update_title Titles of available updates.
! 	 * }
! 	 * @param array $titles An array of update counts and UI strings for available updates.
! 	 */
! 	return apply_filters( 'wp_get_update_data', $update_data, $titles );
  }
  
  function _maybe_update_core() {
***************
*** 426,431 ****
--- 562,579 ----
  
  	if ( !wp_next_scheduled('wp_update_themes') && !defined('WP_INSTALLING') )
  		wp_schedule_event(time(), 'twicedaily', 'wp_update_themes');
+ 
+ 	if ( ! wp_next_scheduled( 'wp_maybe_auto_update' ) && ! defined( 'WP_INSTALLING' ) ) {
+ 		// Schedule auto updates for 7 a.m. and 7 p.m. in the timezone of the site.
+ 		$next = strtotime( 'today 7am' );
+ 		$now = time();
+ 		// Find the next instance of 7 a.m. or 7 p.m., but skip it if it is within 3 hours from now.
+ 		while ( ( $now + 3 * HOUR_IN_SECONDS ) > $next ) {
+ 			$next += 12 * HOUR_IN_SECONDS;
+ 		}
+ 		$next = $next - get_option( 'gmt_offset' ) * HOUR_IN_SECONDS;
+ 		wp_schedule_event( $next, 'twicedaily', 'wp_maybe_auto_update' );
+ 	}
  }
  
  if ( ( ! is_main_site() && ! is_network_admin() ) || ( defined( 'DOING_AJAX' ) && DOING_AJAX ) )
***************
*** 433,449 ****
--- 581,602 ----
  
  add_action( 'admin_init', '_maybe_update_core' );
  add_action( 'wp_version_check', 'wp_version_check' );
+ add_action( 'upgrader_process_complete', 'wp_version_check', 10, 0 );
  
  add_action( 'load-plugins.php', 'wp_update_plugins' );
  add_action( 'load-update.php', 'wp_update_plugins' );
  add_action( 'load-update-core.php', 'wp_update_plugins' );
  add_action( 'admin_init', '_maybe_update_plugins' );
  add_action( 'wp_update_plugins', 'wp_update_plugins' );
+ add_action( 'upgrader_process_complete', 'wp_update_plugins' );
  
  add_action( 'load-themes.php', 'wp_update_themes' );
  add_action( 'load-update.php', 'wp_update_themes' );
  add_action( 'load-update-core.php', 'wp_update_themes' );
  add_action( 'admin_init', '_maybe_update_themes' );
  add_action( 'wp_update_themes', 'wp_update_themes' );
+ add_action( 'upgrader_process_complete', 'wp_update_themes' );
+ 
+ add_action( 'wp_maybe_auto_update', 'wp_maybe_auto_update' );
  
  add_action('init', 'wp_schedule_update_checks');
